/*****************************************************
Author  : Knazev33                                                                                                                                                                                                                                                                                                             
Modified by: shodtech.net
Modified by: Shtolcerman Alexandr aka SDRAM85

Chip type           : ATmega8
Clock frequency     : 32768 Hz
*****************************************************/



#asm
   .equ __lcd_port=0x12 ;PORTD
   .equ __lcd_port_en_pin=0x15 ;PORTC
#endasm




#define key1 PINC.3   //KEY1 +      
#define key2 PINC.4   //KEY2 - 
#define key3 PINC.5   //KEY3  
#define key4 PINC.2   //KEY4   
#define key5 PINC.0   //KEY5 L

#define interrupt_0 PIND.2 
#define interrupt_1 PIND.3

#define disp_on_off_control PORTB.5
#define disp_on_off_check PINB.5

#define light  PORTB.0
#define flash_light  PORTB.4    
#define beep PORTB.3
//#define HV_Pump  PORTC.0 

#define power_led PORTB.2 
#define quant_led PORTB.1   



//EEPROM  
eeprom unsigned int Mass[20] =
{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};   //     eeprom  
eeprom unsigned int load1=60;           //        eeprom
eeprom unsigned char LoadTimeNorm=3;        //       eeprom 34_1 SBM
eeprom unsigned char LoadTimeFail=6;        //       eeprom 34_1 SBM
eeprom unsigned char Sound_bitEeprom=0;  //  
//eeprom unsigned char Tx_bitEeprom=0;     //  
//eeprom unsigned char AutoGenEeprom =1;   //  
eeprom unsigned int  zivert=0;           //   (0- 1-uSv) 
eeprom unsigned int  disp_off_time_Eeprom=0;

eeprom unsigned int  Low_battery_voltage_Eeprom=3300; //   
eeprom unsigned int  High_battery_voltage_Eeprom=4000; //     
eeprom unsigned int  div_voltage_Eeprom=120;
eeprom unsigned char reference_voltage_Eeprom=1;

eeprom unsigned int  zamer_Eeprom=0; 
eeprom unsigned int  narabotka_days_Eeprom=0;
eeprom unsigned int  narabotka_hour_Eeprom=0;


//FLASH    
flash unsigned char  m1[4] ={2, 3, 4, 5};  //    3, 4, 5, 2
flash unsigned char  m2[7] ={6, 7, 12, 13, 15};  //  
flash unsigned char  m3[4] ={14, 9, 16};  //   

//---------------------------- -----------------------
typedef unsigned char byte;

eeprom byte bat_chars[56]=
{0b00001110,
 0b00010001,
 0b00010001,
 0b00010001,
 0b00010001,
 0b00010001,
 0b00010001,
 0b00011111,
//-----------------------------
 0b00001110,
 0b00010001,
 0b00010001,
 0b00010001,
 0b00010001,
 0b00010001,
 0b00011111,
 0b00011111,
//-----------------------------
 0b00001110,
 0b00010001,
 0b00010001,
 0b00010001,
 0b00010001,
 0b00011111,
 0b00011111,
 0b00011111,
//-----------------------------
 0b00001110,
 0b00010001,
 0b00010001,
 0b00010001,
 0b00011111,
 0b00011111,
 0b00011111,
 0b00011111,
//-----------------------------
 0b00001110,
 0b00010001,
 0b00010001,
 0b00011111,
 0b00011111,
 0b00011111,
 0b00011111,
 0b00011111,
//-----------------------------
 0b00001110,
 0b00010001,
 0b00011111,
 0b00011111,
 0b00011111,
 0b00011111,
 0b00011111,
 0b00011111,
//-----------------------------
 0b00001110,
 0b00011111,
 0b00011111,
 0b00011111,
 0b00011111,
 0b00011111,
 0b00011111,
 0b00011111};

//----------------------------------------------------------

struct nar
{
// 
unsigned int  days;
unsigned char hour;
unsigned char minute;
unsigned char sec; 
unsigned int  hour_current;
}narabotka={0,0,0,0,0};



unsigned int maximum_fon=0;   //     .

unsigned int Low_battery_voltage,High_battery_voltage;
unsigned int div_voltage=0;
bit          reference_voltage=0;

unsigned int k=0;             // 
unsigned int geiger1=0;       //   1
unsigned int geiger2=0;       //   2

 
//unsigned char ecco=0;         //  
unsigned char Index=0;        //   
unsigned char sec=0;          //   
unsigned char tick_timer2=0;  //    2
unsigned char AlarmTime;      //  
unsigned char butt;           //     ()
unsigned char butt_light;     //   , 

//
unsigned int  rf=0;          //      =  18
unsigned int  rf_last=0;     //      =  18
unsigned char j=0;           //   
unsigned char Menu=2;        //  
unsigned int  m_buffer=0;    //  

unsigned char  disp_sec=0;
unsigned char  disp_min=0;


char Str_LCD[20];            //    
//
unsigned int  tm[50];        //   
unsigned char tp=80;         //  
unsigned char ti=0;          //   
unsigned char ti2=0;         //   2 
unsigned int  ts1;           //  
unsigned int  ts2;           //        
unsigned int  VoltLevel;     //  
unsigned char im1=1;         //  
unsigned char im2=0;         //  
unsigned char ecco2;         //  
unsigned int  a,b;
//
unsigned int warn;           //   
unsigned char TimeCount;     //     1

unsigned char MCUCR_def;     //     
unsigned char div_tim2;      // .   2
//
bit err=0;                   //   
bit sbm_norm=1;              //    
bit ok=0;                    //  
bit x=0;                     //  
bit AlarmMode=1;             //       1-
bit Ce=0;                    //    
bit sing;                    //   :
bit bit_L;                   //       
bit bit_fL;                   //  
bit key_lock=0;              //   
bit Alarm_is_On=0;           //    
bit Sound_bit;               // 
//bit AutoGen_bit;             //  
//bit TX_PC_Bit;               //    
//bit Tx_bit;
bit zivert_bit;              //  
bit disp_on_off;	         //    /
bit nar_position=0;          //    
bit set_ed=0;                //  / 
bit ed_ok=0;                 //    
bit do_work=1;               //  ,    
bit beep_st=0;               //   
//bit HV_Pump_st=0;          //   
bit setup_menu=0;

unsigned char sleep_power_led=0; //,       4  

unsigned char sbm_error_count_1=0;
unsigned char sbm_error_count_2=0;

unsigned int ed_mass[15];    //     
unsigned char t_sec=0;       //    
unsigned char hour;          //   
unsigned char min;           //  
unsigned char numm=0;        //   
unsigned int ed=0;           //   
unsigned int zamer=0;        //   
unsigned char bat_level=0x00;
unsigned char disp_off_time;
                    
#include <stdio.h> 
#include <mega8.h>
#include <delay.h>
#include <lcd_rus.h>      
#include "gamma.h"
#include "interrupt.h"
#include "display_data.h"   //  
#include "mmenu.h"


//------------------------------------------ ----------------------------------------//
void main(void)
{             
	PORTC=0b01111101; //0x5c
	DDRC= 0b00000010;  //0x3b

	PORTB=0b11100010; //0xFE
	DDRB= 0b00101111;  //0x21

    
    PORTD=0x00;
    DDRD=0x00;

	ACSR=0x80;   //  

	//-----------------------------------2------------------------------ 
	TCCR2=0x00;                 //07
	TCNT2=0xFF;                //  255 
	
	//--------------------------------------------------------------------------
	TIMSK=0x40;                              //   (  2)

	//-------------------------------------------------------------------------------------//
	ACSR=0x80; 
	ADCSRA=0x00;    //off
	ADMUX=0xC7;   //  1 

	//---------------------------------------------------------------------------------

	GICR=0x00;    //    
	MCUCR=0x0F;   //
	GIFR=0xC0;     //

    beep=0;
	//HV_Pump=0;
      
	zivert_bit=zivert;
	disp_off_time=disp_off_time_Eeprom;
        
	Low_battery_voltage=Low_battery_voltage_Eeprom; //   
	High_battery_voltage=High_battery_voltage_Eeprom; //   
        div_voltage=div_voltage_Eeprom;
        reference_voltage=reference_voltage_Eeprom;
        
	TimeCount = LoadTimeNorm;                  //        
	//Tx_bit = Tx_bitEeprom;                 //    
	//AutoGen_bit = AutoGenEeprom;    // 
	Sound_bit = Sound_bitEeprom;     //     
	warn=load1;     //                    
        zamer=zamer_Eeprom;
        narabotka.hour=narabotka_hour_Eeprom;
        narabotka.days=narabotka_days_Eeprom;   
    
    
	if(!warn){AlarmMode = 0;}                //   
        else                 
		 {AlarmMode = 1;}                //   


	//--------------------------------------------------------------//
	disp_on_off=1;
	disp_on_off_control=0;
	delay_ms(5);
	lcd_init(16);     //  
	_lcd_ready();         //
	bat_load();       //     
               
	ASSR=0x08;                  //   
       	TCCR2=0x07;                 //   2 (128) = 256   
        MCUCR_def=0xB0;             // Power-safe  + INT1  
	    MCUCR=MCUCR_def;            
	    div_tim2=0xFF;              //.  2  1

        bit_L++; 
        light=bit_L;


        welcome_window();

	#asm("cli");                //    
	#asm("sei");                //   
        

        for(j=0;j<60;j++) //           
        {
               // HV_Pump=1;
                delay_us(500);
                //HV_Pump=0;
                MCUCR=MCUCR_def;       //   
                #asm("sleep");         //  
                if((!key1)&(!key3)&(!key5)){my_beep_delay_350();while((!key1)&(!key3)&(!key5));Menu=m3[0];im2=1;setup_menu=1;} //  
        }

	//HV_Pump=1; 
        MCUCR=MCUCR_def;       //   
        #asm("sleep");         //  
	j=0;
	rf=0;    
        calculate_battarey(); //        
       
    	GICR|=0xC0;

        Ce=1;  
	while (1)          //--------------- ---------------------
	{
        calculate_counters(); // -----   -----

	        if(do_work)
		{
		  	if(!((Alarm_is_On)&(AlarmMode)))my_keys();      //   ,   
            if(!((Alarm_is_On)&(AlarmMode)))Get_light(); 
		    Get_Warn(); 
          

        	//Usart();                     
            
			if (disp_on_off){main_menu();}
            
		  	do_work=0;
		}
	        else
		{  	
			MCUCR=MCUCR_def;       //   
			#asm("sleep");         //  

		}

	 };                               //     
}                                         //     